/* Expectationvalues etc. of EF */
/*
  09.11.99: all struct sbase (large) now as static
  TODO:
     + get_expvalue(vec1,vec2,operatorfkt,parameterblk) => see wopij
     + operatorfkt(parameterblk,kfgbuffer)  Op sum a_i|kfg_i>=sum b_i|kfg_i> 
     + sbase => hbuf???
     + parallelize wopij (all your functions become parallel than)
  
*/
#include "spins.h"
#include "xval.h"
#include "symmetry.h"
#include "tbase.h"
#include "block.h"
#include "lintab.h"
#include "array_m.h"
#include "vector.h"

ULong	x_max;	/* maximum number of coeff. 0..MAXx set in daten.i */

/* --------------------------------------------------------------------
 * -------- output coefficients of eigenvector v0 to file *f ----------
 * --------------------------------------------------------------------
 * sort coefficients v0_i, and store largest to r[MAXx-1] 
 * mode=0 maximum values
 * mode=1 minimum values
 */
int x_out(FILE *f,tvec *v0,int mode){
    ULong i,j,k,ix[MAXx],in[MAXx],ii=0l;cplx r1; /* index???, anzahl */
    int i1,i2,i3,i4,i5,i6; tbase b1;
    static double rq[MAXx];    /* mittelwert, abweichungsquadrat */
    double rr,ep=1.e-5;if(x_max>MAXx)x_max=MAXx;
    if(!x_max) return 0;	/* x_max>0 ! */
    for(i=0l;i<x_max;i++){ix[i]=n1+1l;in[i]=0l;rq[i]=0;}  /* initial. */
    for(i=0l;i<n1;i++){ 
      if(x_p>0){				/* gleicher Koeffizient */
        for(j=0l;j<x_max;j++)if(ix[j]<n1)
      	if((rr=fabs(M_f2d(vec_e(v0,i))-M_f2d(vec_e(v0,ix[j]))))<ep){ /* oder Betragsdifferenz */
      	  in[j]++;if(rq[j]<rr)rq[j]=rr;break;}
      	if(j<x_max)continue;else ii++;}	
      for(j=0l;j<x_max;j++){			/* groesserer Koeffizient */
         if(ix[j]<n1){
           if(mode==1){ if( fabs(M_f2d(vec_e(v0,i)))>ep+fabs(M_f2d(vec_e(v0,ix[j]))) )break; }
           else       { if( fabs(M_f2d(vec_e(v0,i)))+ep<fabs(M_f2d(vec_e(v0,ix[j]))) )break; }
         }
         if(j>0l){
           ix[j-1]=ix[j];  /* not very well, ToDo: use pointers */
           in[j-1]=in[j];
           rq[j-1]=rq[j];}
         ix[j]=i;
         in[j]=1l;
         rq[j]=0.0;}} 
    r1=M_f2d(vec_e(v0,ix[x_max-1l]));if(r1!=0.0)r1=fabs(r1)/r1;	/* signum (phase) */
    fprintf(f," x_%lu:\n",ii);j=0l;rr=0;
    for(k=0l,j=1l,i=x_max-1l;j<=x_max;j++,i--)if(ix[i]<n1){
       if(x_p>2){
         fprintf(f," %12.9f",D(Norm(M_f2d(vec_e(v0,ix[i])))*(double)in[i]));/* 12.9f/16.9e */
         fprintf(f," %6lu",in[i]);}
       rr+=Norm(M_f2d(vec_e(v0,ix[i])))*(double)in[i];
       fprintf(f," %s",outc(M_f2d(vec_e(v0,ix[i]))*r1));
       fprintf(f," %5.0e",D(rq[i]));
       b1=getl1(ix[i]);          
       fprintf(f," |%s>",ckfg(b1));
       for(i1=1;i1<sym.num_dkorr;i1++){ i4=i5=i6=0;
           for(i2=   0;i2<nn;i2++)
           for(i3=i2+1;i3<nn;i3++)
           if(sym.korr[i2][i3]==i1) {
             if(geti(b1,i2)==1 && geti(b1,i3)==1)i4++;else
             if(geti(b1,i2)==2 && geti(b1,i3)==2)i5++;else
             i6++;
           }
           printf(" %2d",i6); /* printf("+%2d+%2d",i4,i6); */
       }
       fprintf(f," idx=%ld\n",ix[i]);k+=in[i];
    }  fprintf(f," %12.9f %6lu %12s %5.0e <= sum\n",rr,k,"eps:",ep);
    return(0);
}

/* ---- sort and count the number of different coefficients --- */
int x_sort(FILE *f,tvec *v0,tvec *v1){
  ULong i,j,h,t1; double r1,r2,r3,r4; cplx v;  int blk;
  if(!x_max) return 0;	/* x_max>0 ! */
  if(A_ptr(v1)==0 || A_ptr(v0)==0
   || v0->v[0]==0 ||  v1->v[0]==0) return(0);
  STKa("x_sort",(unsigned long *)&h)
  t1=itime();
  for(blk=0;blk<B_NUM;blk++)
  for(i=0l;i<b_len[blk];i++) v1->v[blk][i]=v0->v[blk][i]; /* copy vector */
  /* --- sortieren nach absoluter Laenge --- bug=arrayueberschreitung !!! */
  /* --- shellsort (R.Sedgewick, Algorithmen in C, Addison-Wesley) --- */
  for(h=1;h<=n1/9;h=3*h+1);	/* Distanzen-Folge ...,364,121,40,13,4,1 */
  for(;h>0;h/=3) for(i=h+1;i<n1;i++) {	/* Bug: i<=n1 !!!??? */
    v=M_f2d(vec_e(v1,i)); j=i;
    while(j>h && fabs(M_f2d(vec_e(v1,j-h)))<fabs(v)){
       *vec_pe(v1,j)=vec_e(v1,j-h); j-=h; }
    *vec_pe(v1,j)=M_d2f(v);
  }						/* sorting complete */
  t1=itime()-t1;fprintf(f," x_sort=%lus",t1);

  for(r2=1e-8;r2>1e-10;r2*=0.25){ 		/* r2=1e-5,1e-6,..,1e-14 */ 
    r1=fabs(M_f2d(vec_e(v1,0)));r4=1.0;    	/* r2=epsilonumgebung */
    for(i=j=1l;i<n1;i++){ 
      r3=fabs(fabs(M_f2d(vec_e(v1,i)))-r1);	/* Abstand vom Nachbarn */
      if(r3>r2){ j++; 			/* Abstand<eps = Gleichheit */
                 if(r3<r4)r4=r3; }		/* kleinster Abstand > eps */
      r1=fabs(M_f2d(vec_e(v1,i))); 
    }
    fprintf(f,"\n A(v,eps=%.0e)=%lu eps2=%.0e",r2,j,r4);
  }

  STKe(); return(0);
}

cplx wh(tvec *v0){			/* Erwartungswert <H> */
  cplx rh=0.0;ULong i;double nhn,rd=0; int blk;
  thbuf *hbuf;
  hbuf=alloc_hbuf();
  for(blk=0;blk<B_NUM;blk++){
    hbuf->block=blk;
    for(i=b_ofs[blk];i<b_ofs[blk]+b_len[blk];i++){ 
      rh+=Conj(M_f2d(v0->v[blk][i-b_ofs[blk]]))*fast_nhv(i,v0,&nhn,hbuf);
      rd+=Norm(M_f2d(v0->v[blk][i-b_ofs[blk]]))*nhn;
    }
  }
  printf("\n diag=%12.8f",rd);  /* diag can be different from Ising! */
  free_hbuf(hbuf);
  if(vvv&1)printf(" %s",sclock(~0l));return(rh);
}

double whq(tvec *v0,cplx rh){  /* Fehler Erwartungswert (H*v-h*v)/h */
    double nhn,rq=0.0; ULong i;
    thbuf *hbuf;
    hbuf=alloc_hbuf();
    for(hbuf->block=0;hbuf->block<B_NUM;hbuf->block++){
      for(i=b_ofs[hbuf->block];i<b_ofs[hbuf->block]+b_len[hbuf->block];i++){ 
        rq+=Norm(fast_nhv(i,v0,&nhn,hbuf)
            -rh*M_f2d(v0->v[hbuf->block][i-b_ofs[hbuf->block]])); 
      }
    }
    rq=sqrt(rq/(double)n1);
    free_hbuf(hbuf);
    if(vvv&1)printf(" %s",sclock(~0l));return(rq);
} 

/* -------------------------------------------------------------------
 * mean value <v1|T*v0>/<v0|v0> (v1=v0) and deviation (T|v0>-<T>v0)^2
 * for symmetry T
 *   |k> = q sum_R^l exp(i*k*R) T_R |v>   ( Tx_R |x> = |x+R> ) 
 *       = q sum_m^l exp(i*k*m) T^m |v>   - Fouriertransformation k=2*Pi/l*k
 *   rk  = <v|k>			  q=1/sqrt(sum_m^l exp(i*k*m)^2)=2/l
 *  --- obsolete ---
 */ 
cplx wop_k(tvec *v0,tvec *v1,int ip){
   cplx  r,rh,rn,rk[NN],ik[NN],rc[NN],rs[NN],rt[NN],it[NN];
   ULong i,j;tbase ib1,ib2;tphase s,ss;int k,l,m;
#if defined(SBase)
   static struct sbase l2,b1;
   l2.o=b1.o=0;
#endif
   l=sym.l[ip];rh=rn=0.0;
   if(vvv&1)printf("\n T %5d l= %3d",ip,l);
   for(k=0;k<l;k++)rc[k]=cos((2*M_PI*k)/l)/l;  /* sqrt(2/l) */
   for(k=0;k<l;k++)rs[k]=sin((2*M_PI*k)/l)/l;
   for(k=0;k<l;k++){ ik[k]=rk[k]=0.0;} 
   for(i=0l;i<n1;i++)if(fabs(M_f2d(vec_e(v1,i)))>1e-20){
     ib2=getl1(i);ss=1;
     rn+=Norm(M_f2d(vec_e(v0,i)));
     for(k=0;k<=l/2;k++) it[k]=rt[k]=0.0;
     for(k=0;k<=l/2;k++) rt[k]+=M_f2d(vec_e(v0,i))*rc[0];
     for(m=1;m<l;m++){ ib1=ib2;
       get_symkonfig(ib1,ip,&ib2,&s,0);
#if defined(SBase) && Sym+Sud>0
       b_smallest(ib1,&l2);b_smallest(ib2,&b1);
       j=lin(b1.skfg);ss*=s;r=b1.sign*sqrt((double)l2.norm2/(double)b1.norm2);
#else       
       j=lin(ib2);ss*=s;r=1.0; /* s|j>=T|i> */
#endif
       if(j>=n1){ E2(" lin(%s)=%lu out of range",ckfg(ib2),j); return 0; }
       for(k=0;k<=l/2;k++){
         rt[k]+=r*ss*M_f2d(vec_e(v0,j))*rc[(k*m)%l];
         it[k]+=r*ss*M_f2d(vec_e(v0,j))*rs[(k*m)%l];
       }
     }
     for(k=0;k<=l/2;k++) rk[k]+=(rt[k]*Conj(M_f2d(vec_e(v1,i))));
     for(k=0;k<=l/2;k++) ik[k]+=(it[k]*Conj(M_f2d(vec_e(v1,i))));}
   if(rn==0.0){printf("|v0>=0");rn=1.0;}
   for(k=0;k<=l/2;k++)rh+=Norm(rk[k]/=rn);
   if(vvv&1){ for(k=0;k<=l/2;k++)printf(" %d=%6.3f",k,fabs(rk[k]));}
   return(rh);
}

/* calculate expectation-value of symmetry ip --- obsolete --- */
cplx wop_t(tvec *v0,tvec *v1,int ip){
    cplx rh,rn;ULong i,j;tbase ib2;tphase s;rh=rn=0.0;
    for(i=0l;i<n1;i++)if(fabs(M_f2d(vec_e(v0,i)))>1e-20){
       get_symkonfig(getl1(i),ip,&ib2,&s,0);j=lin(ib2);   /* s|j>=T|i> */
       rh+=Conj(M_f2d(vec_e(v1,i)))*s*M_f2d(vec_e(v0,j)); /*  Sum <iTi> = s<ij> */
       rn+=Norm(M_f2d(vec_e(v0,i)));}
    if(rn!=C(0,0))rh/=rn;else printf("|v0>=0");
    return(rh);
}

/* calculate expectation value of spin-inversion ud --- obsolete --- */ 
cplx wop_ud(tvec *v0,tvec *v1){ /* v1=T*v0  u<->d */
    cplx rh,rq;ULong i;tbase ib2;tphase s;
    if(nu!=nd)return(Z(0.)); rh=Z(0.0);
    for(i=0l;i<n1;i++){ s=1;
      get_sudkonfig(getl1(i),+1,&ib2,&s);s*=sym.wud;
      rh+=Conj(M_f2d(vec_e(v1,lin(ib2))))*s*M_f2d(vec_e(v0,i));}
    if(Re(rh)>=0.0)rq=fabs(rh-1.0); else rq=fabs(rh+1.0);/* rh is +1 or -1 */
    printf(" ud=%4.1f (%5.0e)",D(rh),D(rq));return(rh);
}

/* ??? faster version */
zahl wss(tvec *v0,tvec *v1){ /* SS=1/2*(SpSm+SmSp)+S0^2 ss=s(s+1) */
#ifdef SBase  /* newversion: SS=SZ^2+1/2Sum_(SipSjm+SimSjp) if [SZ,H]=0 */
    ULong i,i2;tbase ib1;int z,iw1,iw2;
    cplx r,rh=0.0,rq=0.0;static struct sbase l2,b1; l2.o=b1.o=0;
    for(i=0l;i<n1;i++){ ib1=getl1(i);r=0.0;
      if(base2ok)l2.norm2=(unsigned Tnorm2)norm2[i];
      else       b_smallest(ib1,&l2);
      CM( z=nn, z=nu+nd, z=0);
#if CM(0,0,1)        
      for(iw1=0;iw1<nn;iw1++)if(zi(ib1,iw1))z++; /* if !JJ */
#endif
      r+=0.5*M_f2d(vec_e(v1,i))*z;		/* Sum_i(S(+,i)S(-,i)) */
      for(iw1=0;iw1<nn-1;iw1++)for(iw2=iw1+1;iw2<nn;iw2++){ /* i<j */
        if(zizj(ib1,iw1,iw2)>=0) continue;
        b_smallest(Flip(ib1,iw1,iw2),&b1);if(phase_eq(b1.sign,0))continue;
        i2=lin(b1.skfg);if(i2>=n1)continue; /* unvollst.basis! */
        r+=M_f2d(vec_e(v1,i2))*b1.sign
             *sqrt((double)l2.norm2/(double)b1.norm2);
      } rh+=r*Conj(M_f2d(vec_e(v0,i)));
    }   rh+=0.25*(nu-nd)*(nu-nd);	/* Z^2+Sum_(i,j)(S(+,i)S(-,j)) */ 
#else   /* #ifdef SBase */
    ULong i;tbase ib1;int z,iw1,iw2;cplx rr,rh=0.0,rq=0.0;
    for(i=0l;i<n1;i++){ ib1=getl1(i);
      for(z=iw1=0;iw1<nn;iw1++)if(zi(ib1,iw1)!=0)z++;
      rr=z*0.5*M_f2d(vec_e(v1,i));
      for(iw1=0;iw1<nn-1;iw1++)for(iw2=iw1+1;iw2<nn;iw2++){ 
        if(zizj(ib1,iw1,iw2)<0)rr+=M_f2d(vec_e(v1,lin(Flip(ib1,iw1,iw2))));
      }
      rh+=rr*Conj(M_f2d(vec_e(v0,i))); }
    rh+=0.25*(nu-nd)*(nu-nd); 
#endif
    printf(" SS= %8.5f",D(rh)); 
    rh=fabs(-1.0+sqrt(1.0+4.0*rh));
    rq=fabs(rh-(int)(fabs(rh)+0.5)); /* allways rh>0 */
    printf(" 2S= %4.1f % 5.0e",D(rh),D(rq)); 
    if(vvv&1)printf(" %s",sclock(~0l));return(D(rh));}
    

cplx wjj(tvec *v0,tvec *v1){ /* SS=1/2*(SpSm+SmSp)+S0^2 ss=s(s+1) */
#if CM(1,0,0)
    if (v0==v1 && v0==0) return 0;
    return 0;
#else
    cplx rh=0.0;
#ifdef SBase
    cplx rq,j0,r;ULong i;tbase ib1;int j,ip1,ip2,iw1,iw2;
    static struct sbase l2,b1;
    l2.o=b1.o=2;
    j0=0.5*(nu+nd-nn);  /* min. Lochzahl */
    for(i=0l;i<n1;i++){
      ib1=getl1(i);b_getbase(ib1,&l2);r=j0*j0*M_f2d(vec_e(v0,i))*l2.norm2; /* ??? */
      if (err_fatal==520) return 0;
      for(j=0;j<l2.num;j++)if(l2.is[j]!=0){
        ib1=l2.ib[j];for(iw1=0;iw1<nn;iw1++)
          if(zizj(ib1,iw1,iw1)==0)r+=0.5*M_f2d(vec_e(v0,i))*l2.is[j]*l2.is[j];
        for(iw1=0;iw1<nn-1;iw1++)for(iw2=iw1+1;iw2<nn;iw2++){
            ip1=geti(ib1,iw1);
            ip2=geti(ib1,iw2);
            if((ip1==0 && ip2==3)||(ip1==3 && ip2==0)){
              b_smallest(Flip(ib1,iw1,iw2),&b1);if(phase_eq(b1.sign,0))continue;
              r+=(1-2*(1&(iw1+iw2)))*M_f2d(vec_e(v0,lin(b1.skfg)))*b1.sign*l2.is[j]
                  *sqrt(l2.norm2/D(b1.norm2));}}} 
      rh+=r*Conj(M_f2d(vec_e(v1,i)))/l2.norm2;} 
#else
    cplx rq,j0,r;ULong i;tbase ib1;int ip1,ip2,iw1,iw2;
    j0=0.5*(nu+nd-nn);  /* JZ=sum() =??? min. Lochzahl */
    for(i=0l;i<n1;i++){
      ib1=getl1(i);r=j0*j0*M_f2d(vec_e(v0,i));
      for(iw1=0;iw1<nn;iw1++)
        if(zizj(ib1,iw1,iw1)==0)r+=0.5*M_f2d(vec_e(v0,i)); /* spin 0 = 3 || . */
      for(iw1=0;iw1<nn;iw1++)for(iw2=iw1+1;iw2<nn;iw2++){
        ip1=geti(ib1,iw1);
        ip2=geti(ib1,iw2);
        if((ip1==0 && ip2==3)||(ip1==3 && ip2==0)){
          r+=1.0*M_f2d(vec_e(v0,lin(Flip(ib1,iw1,iw2))))*(1-2*(1&(iw1+iw2)));}}
      rh+=Conj(M_f2d(vec_e(v1,i)))*r;}
#endif      
    rh=-1.0+sqrt(1.0+4.0*rh);rq=fabs(rh-(int)(fabs(rh)+0.5));   
    printf(" 2J=%4.1f (%5.0e)",D(rh),D(rq));
    return(rh);
#endif
}

cplx wnn(int i1,int i2,tvec *v0,tvec *v1){
#if CM(1,0,0)
    if(v0==v1 && i1==i2) return 1;
    return 1;
#else
    ULong i;cplx rr=0.0;
#if code2
    tbase1 ib1=(tbase1)1<<i1 | (tbase1)1<<i2;
    for(i=0l;i<n1;i++) if((ib1 & getl1(i).u)==ib1) rr+=Conj(M_f2d(vec_e(v1,i)))*M_f2d(vec_e(v0,i)); 
#else
    tbase ib1=((tbase)1<<(2*i1)) | ((tbase)1<<(2*i2));
    for(i=0l;i<n1;i++) if((ib1 & getl1(i))==ib1) rr+=Conj(M_f2d(vec_e(v1,i)))*M_f2d(vec_e(v0,i)); 
#endif
    printf("\n <n%du*n%du>= %9.6f",i1,i2,D(rr));
    return(rr);
#endif    
}

/* --------------- occupation value <v0|n_s|v1> ----------------------
 *  s=3: double occupation on site i
 */
cplx wns(int i1,tvec *v0,tvec *v1,int s){ /* v1=nis*v0 s:1=u,2=d, 3=ud */
#if CM(1,0,0)
    if(i1 && s && v0 && v1) return 1; /* avoid compiler warnings */
    return 1;
#else
    ULong i;cplx rr=0.0;
#if code2
    tbase ib1=((tbase){((s&1)?(tbase1)1<<i1:0),
                       ((s&2)?(tbase1)1<<i1:0)});
    for(i=0l;i<n1;i++) if((ib1.u & getl1(i).u)==ib1.u &&
                          (ib1.d & getl1(i).d)==ib1.d  ) rr+=Conj(M_f2d(vec_e(v1,i)))*M_f2d(vec_e(v0,i));
#else
    tbase ib1=((tbase)s)<<(2*i1);
    for(i=0l;i<n1;i++) if((ib1 & getl1(i))==ib1) rr+=Conj(M_f2d(vec_e(v1,i)))*M_f2d(vec_e(v0,i)); 
#endif
    if(!i1)printf("\n n%d%d=",i1,s);printf(" %9.6f",D(rr));
    return(rr);
#endif
}

/* ------------- Marshall-Peierls phase rule --------------------------------
 * see J.~Richter {\it et. al}, Euro.~Phys.~Lett. {\bf 25}, 545 (1994)
 *     K.~Retzlaff {\it et. al}, Z. Phys. B {\bf 93}, 21-31 (1993)
 * input:  v0=\sum_i a_i |isingstate_i>
 * return: 1-mw   
 *  - weight of coefficients violating the marshall sign rule (wrong sign)
 *    i.e.  sign(a_i) != ms,   where  ms=marshall_sign(isingstate_i,SL)
 *  mw=<v0|((sign(a_i)==ms)?1:0)|v0>
 *
 * definition of the Marshall sign:
 *  ms=(-1)^(Sa-Ma), where Sa=\sum_{i\in A} S_i, Ma=\sum_{i\in A}
 *                   and A is a sublattice defined in sl[]
 *
 * ToDo:
 * - proof for complex vectors or SBase !???
 * - SL-definition is not general??? how to make better definition?
 * - does this definition holt for tJ- and tU-model ???
 * - what about SL-mrule (see J1-J2-model)
 * - SL-rule for triangle lattice (generalization?)
 *
 * ex: N=8-J1J2-chain (noSBase)
 *  ud=4+4 J2=.0   MR=1.000 70+0+0 0.000 E=-3.65109341
 *  ud=4+4 J2=.250 MR=1.000 69+0+1 2e-34 E=-3.28077641
 *  ud=4+4 J2=.251 MR=1.000 62+0+8 5e-09 E=-3.27940480
 *  ud=3+5 J2=.0   MR=1.000 56+0+0 0.000 E=-3.12841906
 *  ud=3+5 J2=.261 MR=1.000 48+0+8 1e-08 E=-2.80266111
 *  ud=2+6 J2=.0   MR=1.000 28+0+0 0.000 E=-1.80193774
 *  ud=2+6 J2=.334 MR=1.000 20+0+8 2e-07 E=-1.33266748
 *  ud=1+7 J2=.293 MR=0.500  4+0+4 0.500 E= 0.58589322
 *  N=16 4x4square J2=0 subMR=0.604116 6470+0+6400 E=-11.22848321
 */
cplx mrule(tvec *v0, int *sl, int num_sl){
  ULong i,j1,j2,j0;tbase b1;int i1,i2,ms,mu,md,site; struct sbase l2;
  double r1,r2;mcplx ai;r1=r2=0.0;j0=j1=j2=0;
  if(num_sl>1)
    for(i=0l;i<n1;i++){ b1=getl1(i);ms=mu=md=1;l2.norm2=1;
      ai=M_f2d(vec_e(v0,i)); /* this is the coefficient i of vector v0 */
#if defined(SBase) /* if symmetry used, MW depend from norm2 */
      l2.num=0;l2.o=0;b_getbase(b1,&l2); /* this makes it slow */
      if (err_fatal==520) return 0;
#else
      l2.num=1; l2.ib[0]=b1; l2.is[0]=1;
#endif
      for(i2=0;i2<l2.num;i2++){ /* not very fast, but works with sym */
        b1=l2.ib[i2]; ms=mu=md=1;
        for(i1=0;i1<nn;i1++)if(sl[i1]==0){ /* check sublattice 0 = A */
          site=geti(b1,i1);  /* 0=empty, 1=up, 2=down, 3=up+down */
          if (site==2) md=-md; else
          if (site==1) mu=-mu;
        } ms=md;
        if(D(ms*l2.is[i2]*ai)<0.0){ j1++; r1+=Norm(ai)/(double)l2.norm2;} else
        if(D(ms*l2.is[i2]*ai)>0.0){ j2++; r2+=Norm(ai)/(double)l2.norm2;} else
                                    j0++; /* count zero coefficients */
      }
    }
  /* if (r1+r2) { rr=1./(r1+r2); r1*=rr; r2*=rr; } */ /* normalize */
  /* sort it before output! */  
  if(r1>r2) printf("\n MRule= %7.5e %ld %ld %ld %7.5e",r1,j1,j0,j2,r2);
  else      printf("\n MRule= %7.5e %ld %ld %ld %7.5e",r2,j2,j0,j1,r1);
  printf(" SL:"); for(i1=0;i1<nn;i1++) printf(" %d",sl[i1]);
  printf(" %s\n",sclock(~0l));
  return(min(r1,r2));
}


/* =================== begin <v0|Op|v1> ============================== */
/* --------------------------------------------------------------------
 * store r*|kfg_i> to hbuf (norm2 too???)
 * fast version for diagonal part ???
 * ToDo: improve nhm from this function?
 */
void puthbuf(thbuf *hbuf,cplx r,tbase kj){
  static struct sbase buf, *bj=&buf; /* better put it to hbuf!??? */
  int ii; ULong j=0;  if(r==0)return;
#ifdef CONFIG_ANSATZ
  if(!ansatz_test(kj)) return;
#endif
  for(ii=0;ii<hbuf->n;ii++)
  if(hbuf->el[ii].kj==kj){ hbuf->el[ii].r+=r; return; } /* already stored? */
#ifdef SBase                  /* r*=(i|kj) */
  bj->o=0;
  kj=b_smallest(kj,bj);if(phase_eq(bj->sign,0))return;
  /* store bj.norm2 too ??? Its calculated here already  */
  r*=bj->sign;
#endif
  j=lin(kj); if(j>=n1) return;
  /* puthbuf(thbuf hbuf, cplx r, tbase kj, ULong j); */
  for(ii=0;ii<hbuf->n;ii++)
  if(hbuf->el[ii].j ==j ){ hbuf->el[ii].r+=r; return; }
  /* sort !??? */
  hbuf->el[hbuf->n].r=r;
  hbuf->el[hbuf->n].kj=kj;
  hbuf->el[hbuf->n].j=j;
  hbuf->n++; if(hbuf->n>=NZXMAX)ERR(9200);
  bj=NULL; /* just avoid not used warning */
  return;
}
/*
 *  example op = op_sisj for wop calculation
 *  decouples operator from vector and symmetry 
 *  and makes the program more flexible
 *  call_by wopij(&op_sisj,NULL,i1,i2,v0,v1);
 */
void op_sisj(void *para,int j1,int j2,thbuf *hbuf){/* hbuf=OP*hbuf */
    tbase ib1,ib2; int z; double r;
    if (para) ; /* avoid Warning, do not care */
    ib1=hbuf->el[0].kj;  /* argument */
    z=zizj(ib1,j1,j2); if(z==0) return; r=0;
    if(j1==j2) r+=0.75;else {
      if(z>0)  r+=0.25;  /* ZiZj */
      else {   r-=0.25;  /* SiSj */
        ib2=Flip(ib1,j1,j2);
        puthbuf(hbuf,(cplx)0.5,ib2); /* put nondiagonal result */
      }
    }
    puthbuf(hbuf,(cplx)r,ib1); /* put diagonal result */
}

/*  ------------------------------------------------------------
 *  use this function to calculate expectationvalues <v0|op|v1>
 *  of your own operator void op(void *param,int i1,int i2,hbuf)
 *  with hbuf=op(kfg,param)
 *  call_by wopij(&op_sisj,&para,i1,i2,v0,v1);
 *  =>  (void (*)(void *,int,int,thbuf *)) &op_sisj
 */
cplx wopij( void (*op)(void *,int,int,thbuf *),void *para,int iw1,int iw2,tvec *v0,tvec *v1){/* <v1|op(i,j)|v0> */
    thbuf *hbuf=alloc_hbuf();
#ifdef SBase /* teilweise falsch bei entartung */
    ULong i,i2;tbase ib1,ib2;int j,j1,n,j2;cplx rh=0.0,r;
    static struct sbase b2,b1;
    b1.o=b2.o=0;
    for(i=0l;i<n1;i++){
      ib1=getl1(i);b_smallest(ib1,&b1);r=0.0;j=0; /* need norm2 */
      for(j2=0;j2<nn;j2++)for(j1=0;j1<=j2;j1++)
      if(sym.korr[j2][j1]==sym.korr[iw2][iw1]){ j++;
        hbuf->n=1;
        hbuf->el[0].kj=ib1;
        hbuf->el[0].r =0;
        hbuf->el[0].j =i;
        (*op)(para,j1,j2,hbuf);  /* calling puthbuf() */
        for(n=0;n<hbuf->n;n++){
            ib2=hbuf->el[n].kj;
            i2 =hbuf->el[n].j;
            b_smallest(ib2,&b2);
            r+=hbuf->el[n].r * M_f2d(vec_e(v1,i2)) * b2.sign
                 * sqrt((double)b1.norm2/(double)b2.norm2);
        }
      } 
      rh+=Conj(r)*M_f2d(vec_e(v0,i))/(j/* *l1.norm2 */);
    } 
#else
    ULong i; int n; cplx rh=0.0,r;
    for(i=0l;i<n1;i++){
      hbuf->n=1;
      hbuf->el[0].kj=getl1(i);
      hbuf->el[0].r =0;
      hbuf->el[0].j =i;
      (*op)(para,iw1,iw2,hbuf); /* calling puthbuf() */
      for(r=0,n=0;n<hbuf->n;n++){
         r += hbuf->el[n].r * M_f2d(vec_e(v1,hbuf->el[n].j));
      }
      rh+=Conj(r)*M_f2d(vec_e(v0,i));
    } 
#endif
    free_hbuf(hbuf);
    return(rh);}

/* =================== end <v0|Op|v1> ============================== */
/* ------------------------------------------------------------------ */

/*
 *  Is the ud-symmetry correct taken into account???
 */
cplx wsisj(int iw1,int iw2,tvec *v0,tvec *v1){/* <v1|SiSj|v0> */
#ifdef SBase
#if 0 /* test it !!! ??? */
    cplx rh = wopij(&op_sisj,NULL,iw1,iw2,v0,v1);
#elif 0 /* change to 0 !!!!!!!!!!!! done */
    /* partly wrong if eigenstate is degenerated */
    ULong i;tbase ib1;int j,z;cplx rh=0.0,r; mcplx *pv1;
    static struct sbase l2,b1;
    l2.o=b1.o=0;
    for(i=0l;i<n1;i++){
      ib1=getl1(i);b_getbase(ib1,&l2);r=0.0;
      if (err_fatal==520) return 0;
      for(j=0;j<l2.num;j++)if(l2.is[j]!=0){
        ib1=l2.ib[j];z=zizj(ib1,iw1,iw2);if(z==0)continue;
        pv1=vec_pe(v1,i);
        if(iw1==iw2) r+=0.75*(*pv1)*l2.is[j]*l2.is[j];else {
          if(z>0)    r+=0.25*(*pv1)*l2.is[j]*l2.is[j];  /* ZiZj */
          else {     r-=0.25*(*pv1)*l2.is[j]*l2.is[j];  /* SiSj */
            b_smallest(Flip(ib1,iw1,iw2),&b1);if(phase_eq(b1.sign,0))continue;
            r+=0.5*M_f2d(vec_e(v1,lin(b1.skfg)))*b1.sign*l2.is[j]
                 *sqrt(l2.norm2/D(b1.norm2));}}} 
      rh+=Conj(r)*M_f2d(vec_e(v0,i))/l2.norm2;} 
#else	/* hoffentlich schneller (mindestens fuer sym.numall>NN*NN) */
    /* teilweise falsch bei entartung */
    ULong i,i2;tbase ib1;int j,j1,j2,z;cplx rh=0.0,r; mcplx *pv1;
    static struct sbase l2,b1;
    l2.o=b1.o=0;
    for(i=0l;i<n1;i++){
      ib1=getl1(i);b_smallest(ib1,&l2);r=0.0;j=0;	/* need norm2 */
      for(j2=0;j2<nn;j2++)for(j1=0;j1<=j2;j1++)	/* [j1][j2]==[j2][j1] Jun99 */
      if(sym.korr[j2][j1]==sym.korr[iw2][iw1]){ j++;
        z=zizj(ib1,j1,j2);if(z==0)continue;
        pv1=vec_pe(v1,i);
        if(j1==j2) r+=0.75*(*pv1);else {
          if(z>0)  r+=0.25*(*pv1);  /* ZiZj */
          else {   r-=0.25*(*pv1);  /* SiSj */
          /* in folgenden Zeilen liegt Fehler bei Entartung */
            b_smallest(Flip(ib1,j1,j2),&b1);if(phase_eq(b1.sign,0))continue;
            i2=lin(b1.skfg);if(i2>=n1)continue;
            r+=0.5*M_f2d(vec_e(v1,i2))*b1.sign
                 *sqrt((double)l2.norm2/(double)b1.norm2);
          }}} 
      rh+=Conj(r)*M_f2d(vec_e(v0,i))/(j/* *l2.norm2 */);} 
#endif
#else
    ULong i;tbase ib1;int z;cplx rh=0.0,r;
    for(i=0l;i<n1;i++){
      r=0.0;ib1=getl1(i);if((z=zizj(ib1,iw1,iw2))==0)continue;
      if(iw1==iw2)r+=0.75*M_f2d(vec_e(v1,i));else {
          if(z>0) r+=0.25*M_f2d(vec_e(v1,i));  /* ZiZj */
          else {  r-=0.25*M_f2d(vec_e(v1,i));  /* SiSj */
                  r+=0.50*M_f2d(vec_e(v1,lin(Flip(ib1,iw1,iw2))));} } 
      rh+=Conj(r)*M_f2d(vec_e(v0,i));}
#endif
    printf("\n i-j %2d %2d SiSj %9.6f",iw1,iw2,D(rh));
    return(rh);}


cplx wzizj(int iw1,int iw2,tvec *v0,tvec *v1){ /* <v1|SiSj|v0> */
#ifdef SBase
    ULong i;int j,j1,j2,z,r;cplx rh=0.0;
    for(i=0l;i<n1;i++){ r=0;j=0;
      for(j2=0;j2<nn;j2++)for(j1=0;j1<=j2;j1++)	/* [j2][j1]==[j1][j2] */
      if(sym.korr[j2][j1]==sym.korr[iw2][iw1]){ j++;
        z=zizj(getl1(i),j1,j2); r+=z; }
      rh+=0.25*r*Conj(M_f2d(vec_e(v1,i)))*M_f2d(vec_e(v0,i))/j; } 
#else
    ULong i;int z;cplx rh=0.0;
    for(i=0l;i<n1;i++){
      z=zizj(getl1(i),iw1,iw2); if(z)rh+=z*0.25*Conj(M_f2d(vec_e(v1,i)))*M_f2d(vec_e(v0,i));} 
#endif
    /* printf("\n i-j %2d %2d ZiZj %9.6f",iw1,iw2,D(rh)); */
    return(rh);}

cplx wzi(int iw1,tvec *v0){ /* <v0|Szi|v0> */
#ifdef SBase
    ULong i;int j1,j,z,r;double rh=0.0;
#ifndef HFIELD
    if( nu!=nd )	/* missing ud-sym, but <Sz>=0 causes <Siz>=0 !??? */
#endif
    for(i=0l;i<n1;i++){
      for(r=j=j1=0;j1<nn;j1++)if(sym.korr[j1][j1]==sym.korr[iw1][iw1]){
        j++; z=zi(getl1(i),j1); r+=z; }
      rh+=0.5*r*Norm(M_f2d(vec_e(v0,i)))/j; } 
#else
    ULong i;int z;double rh=0.0;
    for(i=0l;i<n1;i++){
      z=zi(getl1(i),iw1); if(z)rh+=z*0.5*Norm(M_f2d(vec_e(v0,i)));} 
#endif
    return(rh);}

/* evl. zi()-fkt fuer spin1 in modeldef.h definieren! (allgemeiner) */
/* only for dimer model, spin 1 chains , spin-1 = 2 Spin-1/2 = (4n+2)+(4n+3)
   O(z,pi,i,j)=<v1|Szi*exp(sum(i*Pi*Szk,k=i+1..j))*Szj|v0> |Si|=1*/
int stringorder(FILE *f1,tvec *v0){  
#ifdef SBase
  ULong i;int j,z,k,ex,iw1,iw2;double r,rh;
  static struct sbase l2;
  l2.o=0;
  for(iw2=1;iw2<nn/4;iw2++){ /* max. abstand */
    iw1=0;rh=0.0;
    for(i=0l;i<n1;i++){
      b_getbase(getl1(i),&l2);r=0;
      if (err_fatal==520) return 0;
      for(j=0;j<l2.num;j++)if(l2.is[j]!=0){
        ex=0;for(k=iw1+1;k<=iw2;k++)ex+=zi(l2.ib[j],4*k+2)+zi(l2.ib[j],4*k+3);
        z=(zi(l2.ib[j],4*iw1+2)+zi(l2.ib[j],4*iw1+3))
         *(zi(l2.ib[j],4*iw2+2)+zi(l2.ib[j],4*iw2+3))
         *(1-(2&ex));
        if(z!=0)r+=(z*Norm(l2.is[j]));}  /* l2... noetig? */ 
      rh+=(.25*r)*Norm(M_f2d(vec_e(v0,i)))/(double)l2.norm2; } 
#else
  ULong i;int z,k,ex,iw1,iw2;double rh;
  for(iw2=1;iw2<nn/4;iw2++){ /* max. abstand */
    iw1=0;rh=0.0;    
    for(i=0l;i<n1;i++){   		/* zi(kfg,site)=-1,0+1 */
      ex=0;for(k=iw1+1;k<=iw2;k++)ex+=zi(getl1(i),4*k+2)+zi(getl1(i),4*k+3);
      z=(zi(getl1(i),4*iw1+2)+zi(getl1(i),4*iw1+3))
       *(zi(getl1(i),4*iw2+2)+zi(getl1(i),4*iw2+3))
       *(1-(2&ex));
      if(z!=0)rh+=(z/4)*Norm(M_f2d(vec_e(v0,i)));} 
#endif
    /* mit kommentar, kann mit shelltools beseitigt werden (awk) */
    fprintf(f1," O(z,pi,%d,%d)= %9.6f",iw1,iw2,rh);
  } printf(" <- string-order\n");return 0;}

/* only for spin 1 chains , spin-1 = 2 Spin-1/2 = (4n+2)+(4n+3)
   O(z,pi,i,j)=<v1|Szi*exp(sum(i*Pi*Szk,k=i+1..j))*Szj|v0> |Si|=1*/
int stringorder2(FILE *f1,tvec *v0){  
#ifdef SBase
  ULong i;int j,z,k,ex,iw1,iw2;double r,rh;
  static struct sbase l2;
  l2.o=0;
  for(iw2=1;iw2<nn/2;iw2++){ /* max. abstand */
    iw1=0;rh=0.0;
    for(i=0l;i<n1;i++){
      b_getbase(getl1(i),&l2);r=0;
      if (err_fatal==520) return 0;
      for(j=0;j<l2.num;j++)if(l2.is[j]!=0){
        ex=0;for(k=iw1+1;k<=iw2;k++)ex+=zi(l2.ib[j],k)+zi(l2.ib[j],k+nn/2);
        z=(zi(l2.ib[j],iw1)+zi(l2.ib[j],iw1+nn/2))
         *(zi(l2.ib[j],iw2)+zi(l2.ib[j],iw2+nn/2))
         *(1-(2&ex));
        if(z!=0)r+=(z*Norm(l2.is[j]));}  /* l2... noetig? */ 
      rh+=(0.25*r)*Norm(M_f2d(vec_e(v0,i)))/(double)l2.norm2; } 
#else
  ULong i;int z,k,ex,iw1,iw2;double rh;
  for(iw2=1;iw2<nn/2;iw2++){ /* max. abstand */
    iw1=0;rh=0.0;    
    for(i=0l;i<n1;i++){   		/* zi(kfg,site)=-1,0+1 */
      ex=0;for(k=iw1+1;k<=iw2;k++)ex+=zi(getl1(i),k)+zi(getl1(i),k+nn/2);
      z=(zi(getl1(i),iw1)+zi(getl1(i),iw1+nn/2))
       *(zi(getl1(i),iw2)+zi(getl1(i),iw2+nn/2))
       *(1-(2&ex));
      if(z!=0)rh+=(z/4)*Norm(M_f2d(vec_e(v0,i)));} 
#endif
    /* mit kommentar, kann mit shelltools beseitigt werden (awk) */
    fprintf(f1," O(z,pi,%d,%d)= %9.6f",iw1,iw2,rh);
  } printf(" <- string-order\n");return 0;}

/* Z=<> */
#ifdef SBase
cplx wzijk(int iw1, ...){  
    return((iw1)?0.0:0.0);}	/* no warning !? */
#else
cplx wzijk(int iw1,int iw2,int iw3,tvec *v0,tvec *v1){
    ULong i;tbase ib1;int z;cplx rh=0.0,rr;
    for(i=0l;i<n1;i++){ ib1=getl1(i); rr=0.0;
      z=zizj(ib1,iw1,iw2);
      if(z)rr+=zi(ib1,iw1)*Conj(M_f2d(vec_e(v0,lin(Flip(ib1,iw1,iw2))))); 
      z=zizj(ib1,iw2,iw3);
      if(z)rr+=zi(ib1,iw2)*Conj(M_f2d(vec_e(v0,lin(Flip(ib1,iw2,iw3))))); 
      z=zizj(ib1,iw3,iw1);
      if(z)rr+=zi(ib1,iw3)*Conj(M_f2d(vec_e(v0,lin(Flip(ib1,iw3,iw1)))));
      rh+=rr*M_f2d(vec_e(v1,i));
    }
    return(rh);}
#endif

#if defined(N1) && defined(N2) && N1>1 
cplx wdx(tvec *v0){
    ULong i;tbase ib1;int i1,i2,z0;cplx rdx=0.0,r;
    for(i=0l;i<n1;i++){ ib1=getl1(i); 
      /* Dimer Order Dx */
      r=0.0;for(i1=0;i1<nn;i1++){
       i2=site_move(i1,1,0,0);z0=zizj(ib1,i1,i2);
       r+=(1-2*((i1+i1/(nn/N1))&1))
         *(M_f2d(vec_e(v0,i))*z0+((z0==-1)?2:0)
          *M_f2d(vec_e(v0,lin(Flip(ib1,i1,i2)))));} 
      rdx+=2*Norm(0.25*r/nn); } /* (c)?a:b;  a,b != cplx gnu 2.5.8 */
    return rdx;}
    
cplx wdy(tvec *v0){
    ULong i;tbase ib1;int i1,i2,z0;cplx rdy=0.0,r;
    for(i=0l;i<n1;i++){ ib1=getl1(i);
      /* Dimer Order Dy */
      r=0.0;for(i1=0;i1<nn;i1++){
       i2=site_move(i1,0,1,0);z0=zizj(ib1,i1,i2);
       r+=(1-2*((i1/(nn/N1))&1))
         *(M_f2d(vec_e(v0,i))*z0+((z0==-1)?2:0)*M_f2d(vec_e(v0,lin(Flip(ib1,i1,i2)))));} 
      rdy+=2*Norm(0.25*r/nn);}
    return rdy;}

cplx wc(tvec *v0){
    ULong i;tbase ib1;int i1,i2,z0;cplx rc=0.0,r;
    for(i=0l;i<n1;i++){ ib1=getl1(i);
      /* Collinear Order C */
      r=0.0;for(i1=0;i1<nn;i1++){
       i2=site_move(i1, 1,0,0);z0=zizj(ib1,i1,i2);
       r+=(M_f2d(vec_e(v0,i))*z0+((z0==-1)?2:0)*M_f2d(vec_e(v0,lin(Flip(ib1,i1,i2)))));
       i2=site_move(i1,-1,0,0);z0=zizj(ib1,i1,i2);
       r+=(M_f2d(vec_e(v0,i))*z0+((z0==-1)?2:0)*M_f2d(vec_e(v0,lin(Flip(ib1,i1,i2)))));
       i2=site_move(i1,0, 1,0);z0=zizj(ib1,i1,i2);
       r-=(M_f2d(vec_e(v0,i))*z0+((z0==-1)?2:0)*M_f2d(vec_e(v0,lin(Flip(ib1,i1,i2)))));
       i2=site_move(i1,0,-1,0);z0=zizj(ib1,i1,i2);
       r-=(M_f2d(vec_e(v0,i))*z0+((z0==-1)?2:0)*M_f2d(vec_e(v0,lin(Flip(ib1,i1,i2)))));
      } rc+=Norm(0.125*r/nn);}
    return rc;}

cplx wz(tvec *v0){
    ULong i;tbase ib1;int i1,z0,sx,zx,sy,zy,sxy,zxy;cplx rz=0.0,r;
    for(i=0l;i<n1;i++){ ib1=getl1(i);
      /* better ?? ######### <kfg|Op(i,j,k)*v0> ########################### */
      /* Zi=<[1/(2N)Sum(Z(i,i+x,i+x+y)-Z(i,i+x+y,i+y))]^2>, Zijk=8(ez*Gijk)
       * Eijk=Si(Sj x Sk), Gijk=(Si+Sj+Sk)Eijk 
       *  Chiral Order Z */  
      r=0.0;for(i1=0;i1<nn;i1++){ z0 =zi(ib1,i1);
      /*  site 0..NN, direction 0..2, steps ..,-1,0,1,.. */
       sx =site_move(i1,1,0,0);     zx =zi(ib1,sx);
       sy =site_move(i1,0,1,0);     zy =zi(ib1,sy);
       sxy=site_move(sx,0,1,0);     zxy=zi(ib1,sxy);
       if(z0*zx <0)r+=zx *M_f2d(vec_e(v0,lin(Flip(ib1,i1 ,sx )))); 
       if(zx*zxy<0)r+=zxy*M_f2d(vec_e(v0,lin(Flip(ib1,sx ,sxy)))); 
       if(zxy*z0<0)r+=z0 *M_f2d(vec_e(v0,lin(Flip(ib1,sxy,i1 )))); 
       if(z0*zxy<0)r-=zxy*M_f2d(vec_e(v0,lin(Flip(ib1,i1 ,sxy)))); 
       if(zxy*zy<0)r-=zy *M_f2d(vec_e(v0,lin(Flip(ib1,sxy,sy )))); 
       if(zy*z0 <0)r-=z0 *M_f2d(vec_e(v0,lin(Flip(ib1,sy ,i1 ))));} 
      rz+=Norm(0.5*r/nn);}
    return rz;}

int wtatb(cplx *rta, cplx *rtb, tvec *v0){
    ULong i;tbase ib1;int i1,z0,sx,zx,sy,zy,sxy,zxy;cplx r,r1,r2;
    (*rta)=(*rtb)=0.0;
    for(i=0l;i<n1;i++){ ib1=getl1(i);
      /* better ?? ######### <kfg|Op(i,j,k)*v0> ########################### */
      /* TA=<[1/N Sum(E(i,+x,+x+y)+E(+x+y,+y,i)+E(+y,i,+x)+E(+x,+x+y,+y)]^2>
       * TB=<[1/N Sum(E(i,+x,+x+y)+E(+x+y,+y,i)-E(+y,i,+x)-E(+x,+x+y,+y)]^2>
       * Eijk=Si(Sj x Sk)=1/(2i)Det([[Sim,Sip,Siz],[Sjm,Sjp,Sjz],[Skm,Skp,Skz]]) 
       * Chiral Order TA,TB */  
      r1=r2=0.0;for(i1=0;i1<nn;i1++){ z0 =zi(ib1,i1); 
       sx =site_move(i1,1,0,0);       zx =zi(ib1,sx);
       sy =site_move(i1,0,1,0);       zy =zi(ib1,sy);
       sxy=site_move(sx,0,1,0);       zxy=zi(ib1,sxy);  r=0.0;
       if(z0*zx <0)r+=zxy*zx*M_f2d(vec_e(v0,lin(Flip(ib1,i1 ,sx ))));
       if(zx*zxy<0)r+=z0*zxy*M_f2d(vec_e(v0,lin(Flip(ib1,sx ,sxy))));
       if(zxy*z0<0)r+=zx*z0 *M_f2d(vec_e(v0,lin(Flip(ib1,sxy,i1 ))));
       if(zxy*zy<0)r+=z0*zy *M_f2d(vec_e(v0,lin(Flip(ib1,sxy,sy ))));
       if(zy*z0 <0)r+=zxy*z0*M_f2d(vec_e(v0,lin(Flip(ib1,sy ,i1 ))));
       if(z0*zxy<0)r+=zy*zxy*M_f2d(vec_e(v0,lin(Flip(ib1,i1 ,sxy))));r1+=r;r2+=r;r=0.0;
       if(zy*z0 <0)r+=zx*z0 *M_f2d(vec_e(v0,lin(Flip(ib1,sy ,i1 ))));
       if(z0*zx <0)r+=zy*zx *M_f2d(vec_e(v0,lin(Flip(ib1,i1 ,sx ))));
       if(zx*zy <0)r+=z0*zy *M_f2d(vec_e(v0,lin(Flip(ib1,sx ,sy ))));
       if(zx*zxy<0)r+=zy*zxy*M_f2d(vec_e(v0,lin(Flip(ib1,sx ,sxy))));
       if(zxy*zy<0)r+=zx*zy *M_f2d(vec_e(v0,lin(Flip(ib1,sxy,sy ))));
       if(zy*zx <0)r+=zxy*zx*M_f2d(vec_e(v0,lin(Flip(ib1,sy ,sx ))));r1+=r;r2-=r;} 
      (*rta)+=Norm(0.25*r1/nn);
      (*rtb)+=Norm(0.25*r2/nn);}
    return 0;}
#endif	/* N1>1 */

