#
# --- o2tower.sh --- v2.3.2 Feb2000 JS see line 55!
#                    v2.3.3 Mar2000 JS bug if erg1==erg2 && ss1>ss2 (ss2 taken)
#                                          num2 incorrekt
#                    v2.3.4 Apr2000 JS ud=+/- added
#                    v2.3.5 Apr2000 JS ??? if no convergence detected
#
# convert spin-output file into gnuplot-dat file for energy-spectrum
#
# fulldiag fuer alle sz=0..n/2
#
# sym, erg, sz extrahieren
# sortieren
# doppeltes loeschen
# .dat generieren
# vorher N und E_FM*4 bestimmen
# ggf .5 anhaengen oder %g output (Nov99)
#
awk 'function round(x,d){ return 10**(-d)*int(x*10**d+0.5);}
     BEGIN {erg=100.0;j1=1.0;num=20;line1="";line2="";n1=0;algo=0;nn=0;}
     /i=/&&/t=/{algo=0;line2=line1;line1=$0;if(length(line2)==0)line2=line1}	# store for later
     /eigenvals/{algo=4;num=NF-4;
       for( i1=0; i1<num; i1++){
          printf " %2d %11.7f q%s\n",sz,$(i1+5)/j1,sym
       }
     } 
     /erg/ && algo!=4 { i2=1; num=NF-1;
       for( i1=0; i1<num; i1++){
         estr=round($(i1+2),7) # ignore last digit, better round!!!
         num2=split(line2,a1)
         for(i3=1;i3<=num;i3++){if(round($(i1+2),5)==round(a1[i3],5))break;}

         if(estr!=erg && ( i3<=num || n1<num ) ){
           printf " %2g %12.8f q%s",sz,estr/j1,sym
           # if( i1+1>n1 && round($(i1+2),5)==round($(num+1),5) ) printf " ???"
           if( i3>num || i2>n1 ) printf " ???"
           printf "\n"
           erg=estr
           i2=(i2+1)
         }
       }
     }
     /k_T/ { sym=$4; sud=$2;  }
#     /parameters/ { j1=$2; }
     /MinMem/ { sz=($5-$4)/2;if(sz<0)sz=-sz;n1=$7;nn=$5+$4;
       if(sz==0){ if(sud==0)sym=sym"+";else sym=sym"-"; }
     }
' -  | sort -n -k 2 \
| awk ' function fun1(){
         sum+=num; printf "%2g %11.7f %3d %s %s",ss,erg,num,sym,rest; num=0;
         for(i=0;i<=ss;i++){
#          printf " %d",ea[i];
#          if(i<ss)if(ea[i]>ea[i+1]) printf "\n%2g %11.7f %3d %s",i,erg,0,sym;
#          ea[i]=0;
         }  # entartung[ss]
         if(ss>smin){ smin=ss; printf " low"}
         printf "\n";
        }
      BEGIN { erg=0.0;ss=-1;smin=-1;line="";num=0;sum=0;sym="";rest="";
         for(i=0;i<20;i++) ea[i]=0;  # entartung[ss]
         printf "# o2tower.sh v2.3.5\n#S erg	ea? sym remark\n" }
      END { fun1(); printf "# sum=%d\n",sum }
     !/^#/{
       if(erg!=$2 && ss>=0){ fun1(); }
       if(erg!=$2 || (erg==$2 && ss<$1)){ ss=$1; }
       if(erg!=$2) sym=$3;
       if(index(sym,$3)==0) sym=sym" "$3;
       erg=$2;line=$0;rest=$4; ea[ss]++;
       if(ss>=0){ num=num+1;if(ss>0)num=num+1; }
     }
     /^#/{print}'
